import javax.vecmath.*;

public class LeftWallFollowing {

	//自律走行パラメータ
	double robotWidth = 400;	//ロボット幅
	double minF = 420;
	double maxL = 450;
	double minL = 400;
	double sMaxL = 500;
	double tVel=40;
	double rVel=40;

	int frontNum=0;
	int rightNum=0;
	int right2Num=0;
	int leftNum=0;
	int left2Num=0;
	int front=10000;
	int right=10000;
	int right2=10000;
	int left=10000;
	int left2=10000;

	//左手法走行用カウンタ
	int cnt = 0;
	int cnt2 = 0;
	int cnt3 = 0;

	//速度
	double v=0;
	double w=0;

	//ロボット周囲のLRFデータから速度を求める。
	public Point2d calcVelocity(Point2d[] urgData, boolean robotFlag){

		Point2d velocity=new Point2d(0,0);

		if(urgData != null){
			front=10000;
			left=10000;
			left2=10000;
			right=-10000;
			right2=-10000;

			frontNum = urgData.length/2;
			leftNum = urgData.length-1;
			left2Num = urgData.length-1;
			rightNum = 0;
			right2Num = 0;



			//シミュレータのLRFデータをURG型に変換する
//			if(!robotFlag){	//シミュレータなら
//				if(urgData !=null){
//					Point2d[] simuUrgData = new Point2d[urgData.length];
//					for(int i=0;i<urgData.length;i++){
//						if(urgData[i] != null){
//							simuUrgData[i] = new Point2d(urgData[i].x, urgData[i].y);
//						}
//					}
//					for(int i=0;i<90;i++){
//						if(simuUrgData != null && simuUrgData.length ==180){
//							if(simuUrgData[i] !=null){
//								urgData[i]=new Point2d(simuUrgData[i+90].x, simuUrgData[i+90].y);
//								urgData[i+90]=new Point2d(simuUrgData[i].x, simuUrgData[i].y);
//							}
//						}
//					}
//				}
//			}

			int simuBias=0;
			if(robotFlag){
				simuBias=10;
			}

			//全てのURG点に対して各方向で一番小さい距離を入れる。
			for(int i=0+simuBias; i<urgData.length-simuBias; i++){
				if(urgData[i] != null){
					if(urgData[i].y > -(robotWidth/2+20) && urgData[i].y < (robotWidth/2+20)){
						//前方
						if(urgData[i].x >19 && urgData[i].x <front){
							front = (int)urgData[i].x;
							frontNum = i;
						}
					}

					if(urgData[i].x > -(robotWidth+100) && urgData[i].x < (robotWidth+100)){
						//右前方
						if(urgData[i].x > 0 && urgData[i].y < -19 && urgData[i].y >right){
							right = -(int)urgData[i].y;
							rightNum = i;
						}
						//左前方
						if(urgData[i].x > 0 && urgData[i].y > 19 && urgData[i].y<left){
							left = (int)urgData[i].y;
							leftNum = i;
						}
						//左後方
						if(urgData[i].x < 0 && urgData[i].y > 19 && urgData[i].y <left2){
							left2 = (int)urgData[i].y;
							left2Num = i;
						}
						//右後方
						if(urgData[i].x < 0 && urgData[i].y < -19 && urgData[i].y > right2){
							right2 = -(int)urgData[i].y;
							right2Num = i;
						}
					}
				}
			}
			right=Math.abs(right);
			right2=Math.abs(right2);

//			System.out.print("distance: "+front+", "+right+", "+right2+", "+left+", "+left2);
//			System.out.println("         "+frontNum+", "+rightNum+", "+right2Num+", "+leftNum+", "+left2Num);
//			System.out.println("         "+cnt+","+cnt2+","+cnt3);

			if(left <=minL){	//左の壁にとても近い場合
				if(left<left2){	//前方が近いときは旋回
					v=0;
					w=-0.7*rVel;
//					System.out.println("    ->1");
				}else{			//前方が遠いときは直進
					v=tVel;
					w=0;
//					System.out.println("    ->2");
				}
				cnt = 0;
				cnt2 = 0;
			}
			else if(left >minL && left <=maxL){	//やや近いときはゆっくり前進
				v = 0.5*tVel;
				w=0;
				cnt=0;
				cnt2=0;
//				System.out.println("    ->3");

			}
			else if(left > maxL && left<=sMaxL){	//左の壁に少し遠い→細かく近づく？
				cnt++;
//				System.out.println("    ->4");

				if(cnt>46){	//近づけなかったので、前進しちゃう？
					v=tVel;
					w=-5;
				}
				else if(cnt>36){	//旋回
					v=0;
					w=0.5*rVel;
				}else if(cnt>34){
					v=0.7*tVel;
					w=0;
				}else if(cnt>24){
					v=0;
					w=0.7*rVel;
				}else if(cnt>22){
					v=0.5 * tVel;
					w=0;
				}else if(cnt>12){
					v=0;
					w=0.5*rVel;
				}else if(cnt >10){
					v=0.7*tVel;
					w=0;
				}else{
					v=0;
					w=0.7*rVel;
				}
				cnt2=0;

			}else{		//左の壁から遠い
//				System.out.println("    ->5");
				cnt2++;
				if(cnt2>130){
					v=0.7*tVel;
					w=0;
				}else if(cnt2 >100){
					v=0;
					w=0.1*rVel;
				}else if(cnt2>80){
					v=0.7*tVel;
					w=0;
				}else if(cnt2>50){
					v=0;
					w=0.7*rVel;
				}else if(cnt2>30){
					v=tVel;
					w=0;
				}else if(cnt2>5){
					v=0;
					w=rVel;
				}else{
					v=tVel;
					w=0;
				}
				cnt=0;
			}

			//前方に物体があるとき
			if(front<minF){
//				System.out.println("    ->6");
				v=0;
				w=-rVel;
			}
		}

		velocity = new Point2d(v/100.0,w/100.0);

		return velocity;


	}

}
